local mod = ...




-- Component -------------------------------------------------------------------------------------
local COMP_STORAGE_ASSEMBLAGE = {
	TypeName = "COMP_STORAGE_ASSEMBLAGE",
	ParentType = "COMPONENT",
	Properties = {
		{ Name = "Init", Type = "boolean", Default = false },
		{ Name = "Function", Type = "string", Default = "BUILDING_FUNCTION_WAREHOUSE" },
    }
}



-- Update -------------------------------------------------------------------------------------
function COMP_STORAGE_ASSEMBLAGE:update()

    -- if not self.Init then

    local obj = self:getOwner()

    -- set function
    local compWork = self:getOwner():findFirstObjectWithComponentDown("COMP_WORKPLACE")
    if (compWork) then
        compWork:setWorkplaceData(self.Function)
        mod:log("Storage function set to " .. self.Function)
    end

    -- self destruct
    self:getOwner():removeComponent(self)

        -- obj:forEachComponent(function(comp)
        --     mod:log("Component: " .. tostring(comp))
        -- end)

        -- obj:forEachChild(function(child)
        --     mod:log("   Child: " .. child.Name)
        --     child:forEachComponent(function(compChild)
        --         mod:log("   Child Component: " .. tostring(compChild))
        --     end)

        --     child:forEachChild(function(subChild)
        --         mod:log("      SubChild: " .. subChild.Name)
        --         subChild:forEachComponent(function(compSubChild)
        --             mod:log("      SubChild Component: " .. tostring(compSubChild))
        --         end)

        --         subChild:forEachChild(function(subChild2)
        --             mod:log("         SubChild2: " .. subChild2.Name)
        --             subChild2:forEachComponent(function(compSubChild2)
        --                 mod:log("         SubChild2 Component: " .. tostring(compSubChild2))
        --             end)
        --         end)

        --     end)

        -- end)

        -- obj:forEachComponent(function(comp)
        --     mod:log("   Component: " .. tostring(comp))
        -- end)

        -- Move Paths

        -- local pos = obj:getGlobalPosition()
        -- obj:forEachChild(function(child)

        --     if (child.Name == "PATH_A_1") then
        --         pos = child:getGlobalPosition()
        --         mod:log("Found path a 1 at position: " .. tostring(pos))
        --     end

        --     child:forEachChild(function(subChild)
        --         if (subChild.Name == "WarehousePart") then
        --             subChild:forEachChild(function(subChild2)
        --                 if (string.find(subChild2.Name, "PATH_")) then
        --                     subChild2:setGlobalPosition(pos)
        --                     mod:log("Moved warehouse path to assemblage path location.")
        --                 end
        --             end)
        --         end
        --     end)

        -- end)

        -- -- Remove components
        -- local compRemove = nil
        -- obj:forEachChild(function(child)
        --     child:forEachChild(function(subChild)

        --         if (subChild.Name == "WarehousePart") then

        --             subChild:forEachComponent(function(compSubChild)
        --                 if (tostring(compSubChild) == "Component [\"PlaCCompNavMeshCoreObstacle\"]") then
        --                 -- if (tostring(compSubChild) == "Component [\"PlaCCompBuildingBlocker\"]") or (tostring(compSubChild) == "Component [\"PlaCCompNavMeshCoreObstacle\"]") then
        --                     mod:log("Removing component: " .. tostring(compSubChild))
        --                     subChild:removeComponent(compSubChild)
        --                 end
        --             end)


        --         end

        --     end)
        -- end)


        -- Don't repeat this until the game is reloaded
    --     self.Init = true

    -- end

end



-- Register custom Class
mod:registerClass(COMP_STORAGE_ASSEMBLAGE)



